--[[
************************************************************************
Project				: Broker_TradeCooldowns
Author				: zhinjio
Project Revision	: r37
Project Date		: 20081229040211

File				: Broker_TradeCooldowns.lua
Commit Author		: zhinjio
Commit Revision		: 36
Commit Date			: 20081228212911
************************************************************************
Description	:
	Main addon file. 

TODO		:

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

--------------------------------------------------------------------------------------------------
-- Global SKG variables
--------------------------------------------------------------------------------------------------
BTC_VERSION = 1.0

local BTC = LibStub( "AceAddon-3.0" ):NewAddon( "BTC", "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( "BTC" )
local AceConfig 		= LibStub("AceConfig-3.0")
local AceConfigReg 		= LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 	= LibStub("AceConfigDialog-3.0")
_G["BTC"] = BTC
local addon = BTC

local MODNAME = "BTC"

local addonversion = "r37"
local addonauthor = "zhinjio"
local builddate = "20081229040211"

local db

local tooltip
local LTT = LibStub:GetLibrary( "LibQTip-1.0" )

function BTC_Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\Broker_TradeCooldowns\\icon:" .. fh .. "\124t"
	if not ( msg == nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " BTC: " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function BTC_Debug( msg )
--	local dbf = BTC.db.factionrealm[BTC.me].options.debug
	if not ( msg == nil ) then
		if ( db.options.debug == true ) then
			BTC_Print( "DEBUG: " .. msg )
		end
	end
end

-- coloring functions for tooltip text
local function Red( text )
	return "|cffff0000" .. text .. "|r"
end
local function Yellow( text )
	return "|cffffff00" .. text .. "|r"
end
local function Green( text )
	return "|cff00ff00" .. text .. "|r"
end
local function White( text )
	return "|cffffffff" .. text .. "|r"
end

local classSkills = {
	-- Death Knight
	[L["Blood"]] = true,
	[L["Frost"]] = true,
	[L["Unholy"]] = true,
	-- Druid
	[L["Balance"]] = true,
	[L["Feral Combat"]] = true,
	[L["Restoration"]] = true,
	-- Hunter
	[L["Beast Mastery"]] = true,
	[L["Marksmanship"]] = true,
	[L["Survival"]] = true,
	-- Mage
	[L["Arcane"]] = true,
	[L["Fire"]] = true,
--	[L["Frost"]] = true,
	-- Paladin
	[L["Holy"]] = true,
	[L["Protection"]] = true,
	[L["Retribution"]] = true,
	-- Priest
	[L["Discipline"]] = true,
--	[L["Holy"]] = true,
	[L["Shadow"]] = true,
	-- Rogue
	[L["Assassination"]] = true,
	[L["Combat"]] = true,
	[L["Subtlety"]] = true,
	-- Shaman
	[L["Elemental Combat"]] = true,
	[L["Enhancement"]] = true,
--	[L["Restoration"]] = true,
	-- Warlock
	[L["Affliction"]] = true,
	[L["Demonology"]] = true,
	[L["Destruction"]] = true,
	-- Warrior
	[L["Arms"]] = true,
	[L["Fury"]] = true,
--	[L["Protection"]] = true
}

local primarySkills = {
	[L["Alchemy"]] = true,
	[L["Blacksmithing"]] = true,
	[L["Enchanting"]] = true,
	[L["Engineering"]] = true,
	[L["Herbalism"]] = true,
	[L["Inscription"]] = true,
	[L["Jewelcrafting"]] = true,
	[L["Leatherworking"]] = true,
	[L["Mining"]] = true,
	[L["Skinning"]] = true,
	[L["Tailoring"]] = true,
}

local secondarySkills = {
	[L["First Aid"]] = true,
	[L["Cooking"]] = true,
	[L["Fishing"]] = true,
	[L["Riding"]] = true,
}

local armorProficiencies = {
	[L["Cloth"]] = true,
	[L["Leather"]] = true,
	[L["Mail"]] = true,
	[L["Plate Mail"]] = true,
	[L["Shield"]] = true,
}

local weaponSkills = {
	[L["Axes"]] = true,
	[L["Bows"]] = true,
	[L["Crossbows"]] = true,
	[L["Daggers"]] = true,
	[L["Defense"]] = true,
	[L["Maces"]] = true,
	[L["Guns"]] = true,
	[L["Polearms"]] = true,
	[L["Staves"]] = true,
	[L["Swords"]] = true,
	[L["Thrown"]] = true,
	[L["Two-Handed Axes"]] = true,
	[L["Two-Handed Maces"]] = true,
	[L["Two-Handed Swords"]] = true,
	[L["Unarmed"]] = true,
	[L["Wands"]] = true,
}

local languages = {
	[L["Language: Common"]] = true,
	[L["Language: Dwarven"]] = true,
	[L["Language: Darnassian"]] = true,
	[L["Language: Gnomish"]] = true,
	[L["Language: Draenei"]] = true,
	[L["Language: Orcish"]] = true,
	[L["Language: Troll"]] = true,
	[L["Language: Taurahe"]] = true,
	[L["Language: Gutterspeak"]] = true,
}

local CooldownSpellList = {
-- Initialize my cooldowns list
	-- Alchemy
		-- Northrend Alchemy Research
		[60893] = true,			-- Northrend Alchemy Research
		-- Metals (shared cooldown)
			[11479] = L["Elements"],		-- Transmute: Iron to Gold
			[11480] = L["Elements"],		-- Transmute: Mithril to Truesilver
			[60350] = L["Elements"],		-- Transmute: Titanium
		-- Elements (shared cooldown)
			[17559] = L["Elements"],		-- Transmute: Air to Fire
			[17566] = L["Elements"],		-- Transmute: Earth to Life
			[17561] = L["Elements"],		-- Transmute: Earth to Water
			[25146] = L["Elements"],		-- Transmute: Elemental Fire            
			[17560] = L["Elements"],		-- Transmute: Fire to Earth
			[17565] = L["Elements"],		-- Transmute: Life to Earth           
			[17563] = L["Elements"],		-- Transmute: Undeath to Water
			[17562] = L["Elements"],		-- Transmute: Water to Air            
			[17564] = L["Elements"],		-- Transmute: Water to Undeath
			[28566] = L["Elements"],		-- Transmute: Primal Air to Fire
			[28585] = L["Elements"],		-- Transmute: Primal Earth to Life
			[28567] = L["Elements"],		-- Transmute: Primal Earth to Water
			[28568] = L["Elements"],		-- Transmute: Primal Fire to Earth
			[28583] = L["Elements"],		-- Transmute: Primal Fire to Mana
			[28584] = L["Elements"],		-- Transmute: Primal Life to Earth
			[28582] = L["Elements"],		-- Transmute: Primal Mana to Fire
			[28580] = L["Elements"],		-- Transmute: Primal Shadow to Water
			[28569] = L["Elements"],		-- Transmute: Primal Water to Air
			[28581] = L["Elements"],		-- Transmute: Primal Water to Shadow
			[53777] = L["Elements"],		-- Transmute: Eternal Air to Earth
			[52776] = L["Elements"],		-- Transmute: Eternal Air to Water
			[53781] = L["Elements"],		-- Transmute: Eternal Earth to Air
			[53782] = L["Elements"],		-- Transmute: Eternal Earth to Shadow
			[53775] = L["Elements"],		-- Transmute: Eternal Fire to Life
			[53774] = L["Elements"],		-- Transmute: Eternal Fire to Water
			[53773] = L["Elements"],		-- Transmute: Eternal Life to Fire
			[53771] = L["Elements"],		-- Transmute: Eternal Life to Shadow
			[54020] = L["Elements"],		-- Transmute: Eternal Might           
			[53779] = L["Elements"],		-- Transmute: Eternal Shadow to Earth
			[52780] = L["Elements"],		-- Transmute: Eternal Shadow to Life
			[53783] = L["Elements"],		-- Transmute: Eternal Water to Air
			[53784] = L["Elements"],		-- Transmute: Eternal Water to Fire
		-- Diamonds (shared cooldown)
			[32765] = L["Diamonds"],		-- Transmute: Earthstorm Diamond
			[32766] = L["Diamonds"],		-- Transmute: Skyfire Diamond
			[57425] = L["Diamonds"],		-- Transmute: Skyflare Diamond
			[57427] = L["Diamonds"],		-- Transmute: Earthsiege Diamond
    --Enchanting
		[28027] = true,			-- Prismatic Sphere
		[28028] = true,			-- Void Sphere
    
    -- Jewelcrafting
		[47280] = true,			-- Brilliant Glass    
    
    -- Tailoring        
		[26751] = true,			-- Primal Mooncloth
		[31373] = true,			-- Spellcloth
		[36686] = true,			-- Shadowcloth		
		[56001] = true,			-- Moonshroud
		[56002] = true,			-- Ebonweave
		[56003] = true,			-- Spellweave

    -- Inscription
		[61288] = true,			-- Minor Inscription Research
		[61177] = true,			-- Northrend Inscription Research

	-- Smelting
		[55208] = true,			-- Smelt Titansteel
}

function BTC_prettyTime( seconds )
	local retString = ""
	local left = seconds
	if ( left > 86400 ) then
		local days = floor( left / 86400 )
		left = left % 86400
		retString = retString .. days .. "d"
	end
	if ( left > 3600 ) then
		local hours = floor( left / 3600 )
		left = left % 3600
		retString = retString .. hours .. "h"
	end
	if ( left > 60 ) then
		local mins = floor( left / 60 )
		retString = retString .. mins .. "m"
	end
	return retString
end

function BTC:TRADE_SKILL_SHOW( eventName, ... )
	BTC_Debug( "In " .. eventName )

	-- check to see if this is ours or someone else's
	isLink = IsTradeSkillLinked()
	if ( isLink == nil ) then
		-- Thanks to Ackis (ARL) for scanning code.
		for i = GetNumTradeSkills(), 1, -1 do
			local _, tradeType = GetTradeSkillInfo(i)
			if tradeType == "header" then
				ExpandTradeSkillSubClass(i)
			end
		end
		for i = 1, GetNumTradeSkills() do
			local tradeName, tradeType = GetTradeSkillInfo(i)
			-- Ignore all trade skill headers
			if (tradeType ~= "header") then
				-- Get the trade skill link for the specified recipe
				local SpellLink = GetTradeSkillRecipeLink(i)
				-- Get the SpellID from the spell link
				local SpellID = tonumber( string.match( SpellLink, "enchant:(%d+)" ) )

				-- Is this a spell I track the cooldown of?
				if ( CooldownSpellList[SpellID] ~= nil ) then
					-- Check if there is a current cooldown
					local cooldown = GetTradeSkillCooldown(i)
					if ( cooldown == nil ) then
						BTC_Debug( tradeName .. ", cd is nil" )
						db.cooldowns[SpellID] = {}
						db.cooldowns[SpellID].endtime = 0
						if ( CooldownSpellList[SpellID] ~= true ) then
							db.cooldowns[SpellID].displayName = CooldownSpellList[SpellID]
						else
							db.cooldowns[SpellID].displayName = tradeName
						end
					else
						BTC_Debug( tradeName .. ", cd is " .. cooldown )
						local cd = floor( cooldown )
						currtime = time()
						db.cooldowns[SpellID] = {}
						db.cooldowns[SpellID].endtime = currtime + cd
						if ( CooldownSpellList[SpellID] ~= true ) then
							db.cooldowns[SpellID].displayName = CooldownSpellList[SpellID]
						else
							db.cooldowns[SpellID].displayName = tradeName
						end
					end
				end
			end
		end
	else
		BTC_Debug( "Someone else's tradeskill" )
	end
	addon.updateText()
end

function BTC:COMBAT_LOG_EVENT_UNFILTERED( _, eventType, _, srcName, _, _, _, _, spellId, ...)
	local now = time()
    if ( ( srcName ~= nil ) and
		 ( srcName == BTC.me ) and 
		 ( eventType == "SPELL_CAST_START" ) ) then

		local dbc = db.cooldowns
		-- First, handle the special case items with cooldowns
		if ( spellId == 19566 ) then						-- Salt Shaker
			dbc[spellId].displayName = L["Salt Shaker"]
			dbc[spellId].endtime = now + 252000
		elseif ( spellId == 21935 ) then					-- Snowmaster 9000
			dbc[spellId].displayName = L["Snowmaster 9000"]
			dbc[spellId].endtime = now + 72000
		elseif ( spellId == 26265 ) then					-- Create Elune Stone
			dbc[spellId].displayName = L["Elune's Lantern"]
			dbc[spellId].endtime = now + 72000
		elseif ( CooldownSpellList[spellID] ~= nil ) then
			BTC_Print( L["DETECTED_SPELLCAST"] )
		end
	end
end

function BTC_checkSkills()
	local numSkills = GetNumSkillLines()
	for i = numSkills, 1, -1 do
		local _, isHeader = GetSkillLineInfo(i)
		if ( isHeader ~= nil ) then
			ExpandSkillHeader(i)
		end
	end
	numSkills = GetNumSkillLines()
	BTC_Debug( "numskills = " .. numSkills )
	for i = 1, numSkills do
		local skillName, isHeader, _, skillRank, _, _, skillMaxRank = GetSkillLineInfo(i)
		-- Ignore all trade skill headers
		if ( isHeader == nil ) then
			if ( primarySkills[ skillName ] == true ) then
				db.primary[ skillName ] = {}
				db.primary[ skillName ].currlevel = skillRank
				db.primary[ skillName ].maxlevel = skillMaxRank
			elseif ( secondarySkills[ skillName] == true ) then
				db.secondary[ skillName ] = {}
				db.secondary[ skillName ].currlevel = skillRank
				db.secondary[ skillName ].maxlevel = skillMaxRank
			elseif ( classSkills[ skillName ] == true ) then
				db.class[ skillName ] = true
			elseif ( armorProficiencies[ skillName ] == true ) then
				db.armor[ skillName ] = true
			elseif ( weaponSkills[ skillName ] == true ) then
				db.weapons[ skillName ] = {}
				db.weapons[ skillName ].currlevel = skillRank
				db.weapons[ skillName ].maxlevel = skillMaxRank
			elseif ( languages[ skillName ] == true ) then
				db.languages[ skillName ] = true
			else
				BTC_Debug( L["Unknown skill : %s"] )
			end
		end
	end
end

local function HideTooltip()
	tooltip:SetScript( "OnLeave", nil )
	tooltip:Hide()
end

local LDB = LibStub( "LibDataBroker-1.1", true )
local launcher = LDB:NewDataObject( "BTC", {
	type = "data source",
	text = "",
	label = "Broker_TradeCooldowns",
	icon = "Interface\\Addons\\Broker_TradeCooldowns\\icon",
	OnClick = function(clickedframe, button)
				BTC:ShowConfig()
				addon.updateText()
	end,
	OnEnter = function ( self )
		tooltip:Clear()
		local dbf = BTC.db.factionrealm

		-- Show my primary skills
		tooltip:AddHeader( White( L["Professions :"] ) )
		for k, v in pairs( db.primary ) do
			if ( v.currlevel == v.maxlevel ) then
				tooltip:AddLine( Yellow( "   " .. k ), " ", Yellow( "(" .. v.currlevel .. "/" .. v.maxlevel .. ")" ) )
			else
				tooltip:AddLine( Yellow( "   " .. k ), " ",
					Yellow("(")..Red(v.currlevel)..Yellow("/")..Green(v.maxlevel)..Yellow(")") )
			end
		end
		-- Show Secondary
		if ( db.options.showSecondary == true ) then
			tooltip:AddLine( " " )
			tooltip:AddHeader( White( L["Secondary Skills :"] ) )
			for k, v in pairs( db.secondary ) do
			if ( v.currlevel == v.maxlevel ) then
				tooltip:AddLine( Yellow( "   " .. k ), " ", Yellow( "(" .. v.currlevel .. "/" .. v.maxlevel .. ")" ) )
			else
				tooltip:AddLine( Yellow( "   " .. k ), " ",
					Yellow("(")..Red(v.currlevel)..Yellow("/")..Green(v.maxlevel)..Yellow(")") )
			end
			end
		end
		-- Show Class
		if ( db.options.showClass == true ) then
			tooltip:AddLine( " " )
			tooltip:AddHeader( White( L["Class Skills :"] ) )
			for k, v in pairs( db.class ) do
			   tooltip:AddLine( Yellow( "   " .. k ), " ", " " )
			end
		end
		-- Show Weapon
		if ( db.options.showWeapons == true ) then
			tooltip:AddLine( " " )
			tooltip:AddHeader( White( L["Weapon Skills :"] ) )
			for k, v in pairs( db.weapons ) do
			if ( v.currlevel == v.maxlevel ) then
				tooltip:AddLine( Yellow( "   " .. k ), " ", Yellow( "(" .. v.currlevel .. "/" .. v.maxlevel .. ")" ) )
			else
				tooltip:AddLine( Yellow( "   " .. k ), " ",
					Yellow("(")..Red(v.currlevel)..Yellow("/")..Green(v.maxlevel)..Yellow(")") )
			end
			end
		end
		-- Show Armor
		if ( db.options.showArmor == true ) then
			tooltip:AddLine( " " )
			tooltip:AddHeader( White( L["Armor Proficiencies :"] ) )
			for k, v in pairs( db.armor ) do
			   tooltip:AddLine( Yellow( "   " .. k ), " ", " " )
			end
		end
		-- Show Languages
		if ( db.options.showLanguages == true ) then
			tooltip:AddLine( " " )
			tooltip:AddHeader( White( L["Languages :"] ) )
			for k, v in pairs( db.languages ) do
			   tooltip:AddLine( Yellow( "   " .. k ), " ", " " )
			end
		end
		-- cooldowns
		tooltip:AddLine( " " )
		local Displayed = {}
		tooltip:AddHeader( White( L["Cooldowns :"] ) )
		for k, v in pairs( dbf ) do
			if ( next( v.cooldowns ) ~= nil ) then
				tooltip:AddLine( Yellow( "   " .. k ) )
			end
			for i, a in pairs( v.cooldowns ) do
				local blort = k .. "-" .. a.displayName
				if not ( Displayed[blort] ) then
					Displayed[blort] = true
					local now = time()
					local timeleft = a.starttime
					if ( ( a.endtime == 0 ) or ( now > a.endtime ) ) then
						tooltip:AddLine( Yellow( "      " .. a.displayName ), " ", Green( L["Ready"] ) )
					else
						local pretty = BTC_prettyTime( a.endtime - now )
						tooltip:AddLine( Yellow( "      " .. a.displayName ), " ", Red( pretty ) )
					end
				end
			end
		end
		-- Footer
			tooltip:AddLine(" ")
			local lineNum = tooltip:AddLine( "b" )
			tooltip:SetCell( lineNum, 1, L["Click for Configuration"], "LEFT", 3 )

		tooltip:EnableMouse()
		tooltip:SmartAnchorTo( self )
		tooltip:Show()
	end,
	OnLeave = function ( )
		if MouseIsOver( tooltip ) then
			tooltip:SetScript( 'OnLeave', HideTooltip )
		else
			HideTooltip()
		end
	end,
} )

-- options stuff
local displayOptions = nil
local function giveDisplay()
	if (not displayOptions) then
		displayOptions = {
			order = 4,
			type = "group",
			name = L["Display Options"],
			desc = L["DISPLAY_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 41,
					type	= "header",
					name	= L["Display Options"],
				},
				desc = {
					order	= 42,
					type	= "description",
					name	= L["DISPLAY_OPTIONS_DESC"],
				},
				tooltipscale = {
					order	= 43,
					type	= "range",
					name	= L["Tooltip Scale"],
					desc	= L["TOOLTIP_SCALE_DESC"],
					min		= .7,
					max		= 1.3,
					step	= .05,
					bigStep = .05,
					get		= function() return db.options.tipscale end,
					set		= function( info, v ) 
								db.options.tipscale = v
								tooltip:SetScale( v )
							  end,
				},
				debug = {
					order	= 44,
					type	= "toggle",
					name	= L["Debug"],
					desc	= L["DEBUG_DESC"],
					get		= function() return db.options.debug end,
					set		= function() db.options.debug = not db.options.debug end,
				},
				showweapons = {
					order	= 45,
					type	= "toggle",
					name	= L["Show Weapons"],
					desc	= L["SHOW_WEAPONS_DESC"],
					get		= function() return db.options.showWeapons end,
					set		= function() db.options.showWeapons = not db.options.showWeapons end,
				},
				showsecondary = {
					order	= 46,
					type	= "toggle",
					name	= L["Show Secondary"],
					desc	= L["SHOW_SECONDARY_DESC"],
					get		= function() return db.options.showSecondary end,
					set		= function() db.options.showSecondary = not db.options.showSecondary end,
				},
				showclass = {
					order	= 47,
					type	= "toggle",
					name	= L["Show Class"],
					desc	= L["SHOW_CLASS_DESC"],
					get		= function() return db.options.showClass end,
					set		= function() db.options.showClass = not db.options.showClass end,
				},
				showarmor = {
					order	= 48,
					type	= "toggle",
					name	= L["Show Armor"],
					desc	= L["SHOW_ARMOR_DESC"],
					get		= function() return db.options.showArmor end,
					set		= function() db.options.showArmor = not db.options.showArmor end,
				},
				showlanguages = {
					order	= 49,
					type	= "toggle",
					name	= L["Show Languages"],
					desc	= L["SHOW_LANGUAGE_DESC"],
					get		= function() return db.options.showLanguages end,
					set		= function() db.options.showLanguages = not db.options.showLanguages end,
				},
				showtext = {
					order	= 50,
					type	= "toggle",
					name	= L["Show Text"],
					desc	= L["SHOW_TEXT_DESC"],
					get		= function() return db.options.showText end,
					set		= function()
						db.options.showText = not db.options.showText
						addon.updateText()
					end,
				},
				textcooldown = {
					order	= 51,
					type	= "select",
					name	= L["Select Cooldown to Display"],
					desc	= L["SHOW_TEXTCD_DESC"],
					get		= function() return db.options.textCooldown end,
					set		= function( info, value )
						db.options.textCooldown = value
						addon.updateText()
					end,
					values	= function()
						local t = {}
						if ( next( db.cooldowns ) ~= nil ) then
							for k, v in pairs( db.cooldowns ) do
								t[k] = v.displayName
							end
						end
						return t
					end,
					disabled	= function()
						if ( db.options.showText ) then
							if ( next( db.cooldowns ) ~= nil ) then
								return false
							else
								return true
							end
						else
							return true
						end
					end,
				},
			},
		}
	end
	return displayOptions
end

local modularOptions = {}
local options = nil
local function fullOptions()
	if (not options) then
		options = {
			type = "group",
			name = MODNAME,
			args = {
				general = {
					order	= 1,
					type	= "group",
					name	= L["General Information"],
					desc	= L["GENERAL_INFO_DESC"],
					args	= {
						header1 = {
							order	= 11,
							type	= "header",
							name	= L["General Information"],
						},
						desc = {
							order	= 12,
							type	= "description",
							name	= L["GENERAL_INFO_DESC"],
						},
						author = {
							order	= 13,
							type	= "description",
							name	= L["Author : "] .. addonauthor .. "\n",
						},
						version = {
							order	= 14,
							type	= "description",
							name	= L["Version : "] .. addonversion .. "\n",
						},
						builddate = {
							order	= 15,
							type	= "description",
							name	= L["Build Date : "] .. builddate .. "\n",
						},
						dbversion = {
							order	= 15,
							type	= "description",
							name	= L["Database Version : "] .. db.options.dbVersion .. "\n",
						},
						translators = {
							order	= 16,
							type	= "description",
							name	= string.format( L["Helpful Translators (thank you) : %s"],
										"SunTsu(deDE), <CWDG>tnt2ray(zhCN), whynona2(frFR), NightOw1(zhTW), xska(ruRU)" ) .. "\n",
						},
					},
				},
			},
		}
	end
	
	for k,v in pairs(modularOptions) do
		options.args[k] = (type(v) == "function") and v() or v
	end

	return options
end

function addon:SetupOptions()
	AceConfigReg:RegisterOptionsTable(MODNAME, fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(MODNAME, nil, nil, "general")

	-- Fill up our modular options...
	self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function BTC:ShowConfig()
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Display"] )
end

function BTC.updateText()
	local newStr = " "
	if ( db.options.showText ) then
		if ( db.options.textCooldown ~= 0 ) then
			local entry = db.cooldowns[ db.options.textCooldown]
			if ( entry ) then
				newStr = Yellow( entry.displayName ) .. ":"
				local now = time()
				if ( ( entry.endtime == 0 ) or ( now > entry.endtime ) ) then
					newStr = newStr .. Green( L["Ready"] )
				else
					local pretty = BTC_prettyTime( entry.endtime - now )
					newStr = newStr .. Red( pretty )
				end
			end
		end
	end
	launcher.text = newStr
end

function BTC_upgradeDB()
	local olddb = BTC.db.factionrealm[BTC.me]
	-- This checks the current DB version the person has, and upgrades as necessary
	if not ( olddb.options ) then
		-- They have the original version
		olddb.options = {}
		olddb.options = {
			dbVersion = "1.0",
			debug = false,
			showWeapons = false,
			showSecondary = false,
			showClass = false,
			showArmor = false,
			showLanguages = false,
		}
		olddb.weapons = {}
		olddb.primary = {}
		olddb.secondary = {}
		olddb.class = {}
		olddb.languages = {}
		olddb.armor = {}
		olddb.skills = nil
		BTC_Print( string.format( L["Database upgraded to %s"], "1.0" ) )
	end
	if ( olddb.options.dbVersion == "1.0" ) then
		olddb.options.tipscale = 1
		olddb.options.dbVersion = "1.1"
		BTC_Print( string.format( L["Database upgraded to %s"], "1.1" ) )
	end
	if ( olddb.options.dbVersion == "1.1" ) then
		olddb.options.showText = false
		olddb.options.textCooldown = 0
		olddb.options.dbVersion = "1.2"
		BTC_Print( string.format( L["Database upgraded to %s"], "1.2" ) )
	end
end


local function stopScanning()
	if (BTC_ScanFrame) then
		BTC_ScanFrame:SetScript("OnUpdate", nil);
	end
end

function addon.scanSkills()
	-- on first load, there's no real good way to check if the player's skills
	-- are available for scanning yet. So just scan every 5 seconds until they are
	if (not BTC_ScanFrame) then
		BTC_ScanFrame = CreateFrame("Frame")
	end

	local totalElapsed = 0
	local minute = 0

	BTC_ScanFrame:SetScript("OnUpdate", function(self, elapsed)
		totalElapsed = totalElapsed + elapsed
		minute = minute + elapsed
		if totalElapsed < 5 then
			return;
		end
		totalElapsed = 0;
		
		local numSkills = GetNumSkillLines()
		if ( numSkills ~= 0 ) then
			stopScanning()
			BTC_checkSkills()
		end
		if ( minute > 60 ) then
			minute = 0
			addon.updateText()
		end
		return
	end )
end

-- on init
function BTC:OnInitialize()
end

function BTC:OnEnable()
    -- Called when the addon is loaded
    self.db = LibStub( "AceDB-3.0" ):New( "BTC_DB", nil, "Default" )
	if ( not self.db.factionrealm) then
		self.db.factionrealm = {}
	end

	BTC.me = UnitName( "player" )

	-- do we have any data yet for this toon? If not, init its table
	if not ( self.db.factionrealm[BTC.me] ) then
		self.db.factionrealm[BTC.me] = {
			primary = {},
			secondary = {},
			weapons = {},
			class = {},
			languages = {},
			armor = {},
			cooldowns = {},
			options = {
				dbVersion = "1.2",
				debug = false,
				showSecondary = false,
				showWeapons = false,
				showClass = false,
				showArmor = false,
				showLanguages = false,
				showText = false,
				textCooldown = 0,
				tipscale = 1,
			}
		}
	else
		-- check if we need to upgrade the db
		BTC_upgradeDB()
	end

	db = self.db.factionrealm[BTC.me]

	BTC_Debug( "In OnEnable" )

	BTC:SetupOptions()

	-- Check current weapons/languages
	addon.scanSkills()
	addon.updateText()

	tooltip = LTT:Acquire( "BTC_TT", 3, "LEFT", "CENTER", "RIGHT" ) -- or GameTooltip
	tooltip:SetScale( db.options.tipscale )

	-- Event listeners
	BTC:RegisterEvent( "TRADE_SKILL_SHOW" )
	BTC:RegisterEvent( "COMBAT_LOG_EVENT_UNFILTERED" )
	BTC:RegisterEvent( "CHAT_MSG_SKILL", BTC_checkSkills )
end

--[[
************************************************************************
CHANGELOG:

Date : 11/14/08
	IsTradeSkillLinked code (check to see if the tradeskill open is our
	own or someone elses)
	Allow the skills listed to update
	added languages and weapons
	added db_upgrade
	added event for skillups
	added libtooltip
	added tipscale option
Date : 10/29/08
	Initial version
************************************************************************
]]--