--[[
************************************************************************
Project				: Broker_TradeCooldowns
Author				: zhinjio
Project Revision	: r37
Project Date		: 20081229040211

File				: Locales\zhCN.lua
Commit Author		: zhinjio
Commit Revision		: 29
Commit Date			: 20081206221723
************************************************************************
Description	:
	Chinese translation strings
TODO		:
************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]
local L = LibStub:GetLibrary("AceLocale-3.0"):NewLocale("BTC", "zhTW")
if not L then return end

-- Tooltip headings
L["Class Skills :"]			= "职业技能："
L["Professions :"]			= "专业："
L["Secondary Skills :"]		= "辅助技能："
L["Weapon Skills :"]		= "武器技能："
L["Armor Proficiencies :"]	= "护甲精通："
L["Languages :"]			= "语言："
L["Ready"]					= "已就绪"

L["My Skills :"]			= "我的技能："
L["Cooldowns :"]			= "冷却中："
-- Shared Cooldown headings:
L["Elements"]				= "元素转化"
L["Diamonds"]				= "多彩宝石"

-- Items with cooldowns:
L["Salt Shaker"]			= "筛盐器"
L["Snowmaster 9000"]		= "雪王9000型"
L["Elune's Lantern"]		= "艾露恩的灯笼"

-- Messages
L["DETECTED_SPELLCAST"]	= "未能获取到技能的冷却时间，请打开该专业窗口，以便重新获取冷却信息。"
L["Unknown skill : %s"] = "未知技能： %s"
L["Helpful Translators (thank you) : %s"] = "译者： %s"

-- Class Skills
L["Blood"]				= "鲜血"
L["Frost"]				= "冰霜"
L["Unholy"]				= "邪恶"
L["Balance"]			= "平衡"
L["Feral Combat"]		= "野性战斗"
L["Restoration"]		= "恢复"
L["Beast Mastery"]		= "野兽控制"
L["Marksmanship"]		= "射击"
L["Survival"]			= "生存"
L["Arcane"]				= "奥术"
L["Fire"]				= "火焰"
L["Holy"]				= "神圣"
L["Protection"]			= "防护"
L["Retribution"]		= "惩戒"
L["Discipline"]			= "戒律"
L["Shadow"]				= "暗影"
L["Assassination"]		= "刺杀"
L["Combat"]				= "战斗"
L["Subtlety"]			= "敏锐"
L["Elemental Combat"]	= "元素战斗"
L["Enhancement"]		= "增强"
L["Affliction"]			= "痛苦"
L["Demonology"]			= "恶魔学识"
L["Destruction"]		= "毁灭"
L["Arms"]				= "武器"
L["Fury"]				= "狂怒"

-- Primary Skills
L["Alchemy"]		= "炼金术"
L["Blacksmithing"]	= "锻造"
L["Enchanting"]		= "附魔"
L["Engineering"]	= "工程学"
L["Herbalism"]		= "草药学"
L["Inscription"]	= "铭文"
L["Jewelcrafting"]	= "珠宝加工"
L["Leatherworking"]	= "制皮"
L["Mining"]			= "采矿"
L["Skinning"]		= "剥皮"
L["Tailoring"]		= "裁缝"

-- Secondary Skills
L["First Aid"]		= "急救"
L["Cooking"]		= "烹饪"
L["Fishing"]		= "钓鱼"
L["Riding"]			= "骑术"

-- Armor
L["Cloth"]			= "布甲"
L["Leather"]		= "皮甲"
L["Mail"]			= "锁甲"
L["Plate Mail"]		= "板甲"
L["Shield"]			= "盾牌"

-- Weapons
L["Axes"]				= "单手斧"
L["Bows"]				= "弓"
L["Crossbows"]			= "弩"
L["Daggers"]			= "匕首"
L["Defense"]			= "防御"
L["Maces"]				= "单手锤"
L["Polearms"]			= "长柄武器"
L["Staves"]				= "法杖"
L["Swords"]				= "单手剑"
L["Thrown"]				= "投掷武器"
L["Two-Handed Axes"]	= "双手斧"
L["Two-Handed Maces"]	= "双手锤"
L["Two-Handed Swords"]	= "双手剑"
L["Unarmed"]			= "徒手"
L["Wands"]				= "魔杖"

-- Languages
L["Language: Common"]		= "语言：通用语"
L["Language: Dwarven"]		= "语言：矮人语"
L["Language: Darnassian"]	= "语言：达纳苏斯语"
L["Language: Gnomish"]		= "语言：侏儒语"
L["Language: Draenei"]		= "语言：德莱尼语"
L["Language: Orcish"]		= "语言：兽人语"
L["Language: Troll"]		= "语言：巨魔语"
L["Language: Taurahe"]		= "语言：牛头人语"
L["Language: Gutterspeak"]	= "语言：亡灵语"

-- Options strings
L["Database upgraded to %s"]	= "数据库升级为"
L["Tooltip Scale"]				= "鼠标提示缩放"
L["TOOLTIP_SCALE_DESC"]			= "调节鼠标提示的大小"
L["General Information"]		= "综述"
L["GENERAL_INFO_DESC"]			= "插件综述"
L["Author : "]					= "作者："
L["Version : "]					= "版本："
L["Build Date : "]				= "日期："
L["Database Version : "]		= "数据库版本："
L["Display Options"]			= "显示选项"
L["DISPLAY_OPTIONS_DESC"]		= "决定哪些需要显示的项目"
L["Debug"]						= "调试"
L["DEBUG_DESC"]					= "开启调试，将在聊天窗口中显示调试信息"
L["Show Weapons"]				= "显示武器技能"
L["SHOW_WEAPONS_DESC"]			= "开启后将显示武器技能"
L["Show Secondary"]				= "显示辅助技能"
L["SHOW_SECONDARY_DESC"]		= "开启后将显示辅助技能的情况"
L["Show Class"]					= "显示职业技能"
L["SHOW_CLASS_DESC"]			= "开启后将显示职业技能的情况"
L["Show Armor"]					= "显示护甲精通"
L["SHOW_ARMOR_DESC"]			= "开启后将显示护甲精通的情况"
L["Show Languages"]				= "显示语言"
L["SHOW_LANGUAGE_DESC"]			= "开启后将显示语言情况"